Subject: Re: XSysAce driver cant mount DOS part

From: urwithsudheer <[email-masked]>
Date: Mon, 16 Jul 2007 10:38:27 +0530

Hi Joe Robertson,

Thanks for the link.

In the xsa_thread function, can u try changing the hardcoded coded value 
"2" to "xsa_cur_req->current_nr_sectors " 

The actual code in the given link.

for(i = xsa_cur_req->current_nr_sectors; i > 0; i-=2){
+			xsa_device.req_done = 1;
+			while ((stat = cur_req(&SysAce, sector,
+					2,
+					buffer)) == XST_DEVICE_BUSY)
+				xsa_short_delay();

Try changing it to ...

for(i = xsa_cur_req->current_nr_sectors; i > 0; 
i-=xsa_cur_req->current_nr_sectors ){ xsa_device.req_done = 1;
while ((stat = cur_req(&SysAce, sector,
                                     xsa_cur_req->current_nr_sectors ,
                                    buffer)) == XST_DEVICE_BUSY)
                xsa_short_delay();

Due to the hardcoded value, it gave problem while mounting but no issue 
with fdisk. It mounts well but generated a kernel BUG. Tried changing 
the value to '1' from '2' , fdisk crashed but mount is working well. So 
removed the hardcode value and then placed the dynamic variable 
xsa_cur_req->current_nr_sectors which is chosen by kernel. And now fdisk 
and mount both are working fine.

Pl let me know the results in your setup.

Thanks
Sudheer

Robertson, Joseph M. wrote:
>
> Hi,
>
> Yes, I got it from here.
> http://www.cs.york.ac.uk/rtslab/demos/amos/xupv2pro/patches/linuxppc-2.6.17.1-sysace-1.2.patch
>
> The 'official' one, yes?
>
> Thanks,
>
> Joe Robertson
> [email-masked]
>
>
>
> -----Original Message-----
> From: urwithsudheer [mailto:[email-masked]]
> Sent: Fri 7/13/2007 4:25 AM
> To: Robertson, Joseph M.
> Cc: [email-masked]
> Subject: Re: XSysAce driver cant mount DOS part
>
> Hi
>
> Robertson, Joseph M. wrote:
> >
> > Hi all,
> >
> > I've been workig with this for a while but have made no progress.
> > Today I got the latest XSysAce patch for kernel 2.6.17.1 and applied
> > it to get clean code.
> > I inherited the previous code from another developer.
> >
> Can you send the link to xsysace driver source code from where you 
> obtained.
>
>
> Thanks
> Sudheer
>
>
> >
> > My problem is that mounting the DOS partition always fails in a short
> > time with a kernel oops.
> >
> > ECAU-9999:# Oops: kernel access of bad area, sig: 11
> > [#1]                     
> > 
> PREEMPT                                                                       
> > NIP: C00701C8 LR: C0070C18 CTR:
> > 00000000                                      
> > REGS: c0391dd0 TRAP: 0300   Not tainted 
> > (2.6.17.1)                           
> > MSR: 00021030 <ME,IR,DR>  CR: 22028082  XER:
> > 0000000B                         
> > DAR: 00000000, DSISR:
> > 00800000                                                
> > TASK = c0373030[4] 'events/0' THREAD:
> > c0390000                                
> > GPR00: 00000080 C0391E80 C0373030 C02CAC00 C0E03000 C0E03154 00000000
> > C02CAC00
> > GPR08: 00200200 00000000 00100100 00000000 00051A4B FFFFDE60 03BD4900
> > 007FFF3B
> > GPR16: 00400000 00000001 FFFFFFFF 03BCDC58 00000000 007FFF00 00000002
> > C0280000
> > GPR24: C0363A10 0000000B 00000000 00000000 00000000 C02CAC00 C035ED20
> > C0E03000
> > NIP [C00701C8]
> > free_block+0x8c/0x138                                          
> > LR [C0070C18]
> > drain_array+0xb8/0x124                                          
> > Call Trace:                                 
> >
> > The setup:
> > My own build system.
> > Kernel 2.6.17.1 with lots of xilinx stuff, eth, i2c, xsysace. 
> > Crosscompiled for PPC405.
> > Latest, clean XSysAce code.  mods:  major hardcoded to = 125.  Polled
> > mode.
> > CF:  3 partitions,
> > 1:  DOS FAT16
> > 2:  Ext2  main
> > 3:  Ext2  rescue
> >
> > This build boots up fine, mounts a ext2 as root fine.  I can also
> > mount the rescue partition with no problems.
> >
> > Does anyone have any pointers of where I should look for problems?
> >
> > My next step is to go and set it up for interrupt service and see if
> > that changes anything.
> >
> > Thanks,
> >
> > Joe Robertson
> > [email-masked]
> >
> >
> > CONFIDENTIALITY
> > This e-mail message and any attachments thereto, is intended only for
> > use by the addressee(s) named herein and may contain legally
> > privileged and/or confidential information. If you are not the
> > intended recipient of this e-mail message, you are hereby notified
> > that any dissemination, distribution or copying of this e-mail
> > message, and any attachments thereto, is strictly prohibited. If you
> > have received this e-mail message in error, please immediately notify
> > the sender and permanently delete the original and any copies of this
> > email and any prints thereof.
> > ABSENT AN EXPRESS STATEMENT TO THE CONTRARY HEREINABOVE, THIS E-MAIL
> > IS NOT INTENDED AS A SUBSTITUTE FOR A WRITING. Notwithstanding the
> > Uniform Electronic Transactions Act or the applicability of any other
> > law of similar substance and effect, absent an express statement to
> > the contrary hereinabove, this e-mail message its contents, and any
> > attachments hereto are not intended to represent an offer or
> > acceptance to enter into a contract and are not otherwise intended to
> > bind the sender, Sanmina-SCI Corporation (or any of its subsidiaries),
> > or any other person or entity.
> > ------------------------------------------------------------------------
> >
> > _______________________________________________
> > Linuxppc-embedded mailing list
> > [email-masked]
> > https://ozlabs.org/mailman/listinfo/linuxppc-embedded
>
>
>
> CONFIDENTIALITY
> This e-mail message and any attachments thereto, is intended only for 
> use by the addressee(s) named herein and may contain legally 
> privileged and/or confidential information. If you are not the 
> intended recipient of this e-mail message, you are hereby notified 
> that any dissemination, distribution or copying of this e-mail 
> message, and any attachments thereto, is strictly prohibited. If you 
> have received this e-mail message in error, please immediately notify 
> the sender and permanently delete the original and any copies of this 
> email and any prints thereof.
> ABSENT AN EXPRESS STATEMENT TO THE CONTRARY HEREINABOVE, THIS E-MAIL 
> IS NOT INTENDED AS A SUBSTITUTE FOR A WRITING. Notwithstanding the 
> Uniform Electronic Transactions Act or the applicability of any other 
> law of similar substance and effect, absent an express statement to 
> the contrary hereinabove, this e-mail message its contents, and any 
> attachments hereto are not intended to represent an offer or 
> acceptance to enter into a contract and are not otherwise intended to 
> bind the sender, Sanmina-SCI Corporation (or any of its subsidiaries), 
> or any other person or entity.